{ Program wyszukuje wzorzec w tekcie w sposb naiwny }
program wyszukiwanie_naiwne;
uses
  Crt;

const
  DLLancucha = 50;  { dugo acucha }
  DLWzorca = 3;    { dugo wzorca }

  { nasz alfabet bdzie si skada si z trzech liter XYZ,  }
  { z ktrych losowo wygenerujemy acuch }
  ZnPocz = 88;  { kod pierwszego znaku alfabetu, X }
  ZnKonc = 90;  { kod ostatniego znaku alfabetu, Y }

type
  TTabPozycji = array [1..255] of Byte;

{ Procedura wyszukuje w tekcie wzorzec w sposb naiwny. Oznacz to, e }
{ kopiuje z wyjciowego tekstu cig znakw o dugoci wzorca i porwnuje }
{ go z nim. Powtarza te czynnoci od 1 znaku do dkL-dlW+1. }
{ Prcz tego w tablicy zapisuje wszystkie pozycje wystpowania wzorca. }
procedure wyszukaj_wzorzec_I (lancuch, wzorzec : String );
var
  i,
  j,    { wskaznik tablicy tabPoz }
  dlL,
  dlW : Byte;
  tabPoz : TTabPozycji;
  jest : Boolean;
begin
  jest:=false;
  j:=1;
  { zerujemy tablice pozycji }
  fillchar(tabPoz, sizeof(tabPoz),0);
  dlL:=length(lancuch); { dugo ancucha }
  dlW:=length(wzorzec); { dugo wzorca }
  writeln('Metoda naiwna:');
  writeln(lancuch);

  { szukamy wzorca w ancuchu }
  for i := 1 to dlL-dlW+1 do
    if wzorzec = copy(lancuch,i,dlW) then
      begin
        write(char(24));
        tabPoz[j]:=i;
        inc(j);
        jest:=true;
      end
    else write(' ');

  j:=1;
  writeln;
  writeln;

  { jeli jest jaki wzorzec to wywietlamy pozycje na ktrej wystpuje }
  if jest then
    begin
      write('Pozycje wystpowania wzorca: ');
      while tabPoz[j]<>0 do
        begin
          write (tabPoz[j],' ');
          inc(j);
        end;
    end else
      writeln('Brak wzorca');
  writeln;
end;

{ Procedura wyszukaj_wzorzec_II w pewnych przypadkach pomija wzorce. }
{ Odpowiedz dlaczego. Sprbuj tak zmodyfikowa t procedur aby dziaa }
{ identycznie jak procedura wyszukaj_wzorzec_I }
procedure wyszukaj_wzorzec_II (lancuch, wzorzec : String );
var
  i,
  pom,
  ile, { ilo wystpie wzorca }
  dlW : Byte;
  jest : Boolean;
  zaslepka : String;
begin
  jest:=false;
  ile:=0;
  zaslepka:='';
  dlW:=length(wzorzec);

  for i:=1 to dlW do zaslepka:=zaslepka+'_';

  writeln;
  writeln('Metoda naiwna z wykorzystaniem funkcji pos (___ zastpuje wzorzec): ');
  repeat
    pom:=Pos(wzorzec, lancuch);
    if pom>0 then
      begin
        jest:=true;
        delete(lancuch,pom,dlW);
        { wstawiamy zalepk w miejsce wycicia wzorca, ktrego znalelimy }
        { po to aby wyszukao nastpny wzorzec. Zastanw si czy to dobry }
        { pomys }
        insert(zaslepka,lancuch,pom);
        writeln(lancuch);
        inc(ile);
      end;
  until (pom=0);
  writeln('Ilo wystpie wzorca: ',ile);
end;

var
  i : Integer;
  lancuch,
  wzorzec : String;
begin
  clrscr;
  randomize;
  lancuch:='';
  wzorzec:='';

  { generujemy acuch }
  for i := 1 to DLLancucha do
    lancuch := lancuch + chr(ZnPocz + random(ZnKonc - ZnPocz + 1));
  writeln('Tekst, w ktrym bdziemy szuka wzorca:');
  writeln(lancuch);
  writeln;

  { generujemy wzorzec }
  for i := 1 to DLWzorca do
    wzorzec := wzorzec + chr(ZnPocz + random(ZnKonc - ZnPocz + 1));
  writeln('Szukany wzorzec:');
  writeln(wzorzec);
  writeln;
  { szukamy wzorca w ancuchu }
  wyszukaj_wzorzec_I (lancuch,wzorzec);
  wyszukaj_wzorzec_II(lancuch,wzorzec);
  writeln;

  repeat until keypressed;
end.
