{ Program na wydawanie reszty metod zachann }
program wydaj_reszte;
uses
  Crt;
const
  N = 8; { ilo typw nominaw }
type
  TNominaly = array [1..n] of Integer;

{ Funkcja ile_nominalow zwraca najmniejsz liczb monet potrzebnych }
{ do wydania reszty (zmienna typu Integer - uproszczenie dla skrcenia }
{ algorytmu - za pomoc nominaw, ktrych wartoci s zawarte w tablicy }
{ nominay typu TNominaly. }
function ile_nominalow(reszta : Integer; nominaly : TNominaly ) : Integer;
var
  i,
  nominal,
  wynik : Integer;
begin
  wynik:=0;
  repeat
    i:=n;
    while reszta<nominaly[i] do i:=i-1;

    writeln('Nomina:',nominaly[i]);
    wynik:=wynik+1;
    reszta:=reszta-nominaly[i];

  until reszta=0;
  ile_nominalow:=wynik;
end;

{ Druga wersja funkcji zwracajcej najmniejsz liczb monet potrzebnych }
{ do wydania reszty }
function ile_nominalow2(reszta : Integer; nominaly : TNominaly ) : Integer;
var
  i, b,
  nominal,
  wynik : Integer;
begin
  wynik:=0;
  i:=n;
  repeat
    nominal:=nominaly[i]; { przeszukujemy tablice od najwikszego nominau }
    b:=reszta div nominal;
    reszta:=reszta-b*nominal;
    if b> 0 then
      begin
        wynik:=wynik+b;
        writeln('Nomina: ',nominal:4,'  ','sztuk: ',b);
      end;
     i:=i-1;
   until i=0;
   ile_nominalow2:=wynik;
end;

{ Procedura wprowadza list nominaw. Oczywicie mona to tak oprogramowa }
{ aby wczytywa je z klawiatury lub z pliku }
procedure okresl_nominaly (var nominaly : TNominaly);
begin
  nominaly[1]:=1;
  nominaly[2]:=2;
  nominaly[3]:=5;
  nominaly[4]:=10;
  nominaly[5]:=20;
  nominaly[6]:=50;
  nominaly[7]:=100;
  nominaly[8]:=200;
end;

var
  reszta,
  ileMonet : Integer;
  nominaly : TNominaly;
begin
  clrscr;
  writeln('Program okrela ilo monet i banknotw w jakich naley wyda reszt');
  writeln('Wywietla rwnie poszczeglne nominay do wydania');
  write('Podaj kwot reszty: ');
  readln(reszta);
  if reszta > 0 then
    begin
      okresl_nominaly(nominaly);
      ileMonet:=ile_nominalow(reszta,nominaly);
      writeln('I wersja - ilo monet i banknotw: ' ,ileMonet);
      writeln;
      ileMonet:=ile_nominalow2(reszta,nominaly);
      writeln('II wersja - Ilo monet i banknotw: ' ,ileMonet);
    end
  else
    writeln('Aby wyda reszt powinna by ona wiksza od 0');
  repeat until keypressed;
end.
