program sortowanie_szybkie;
uses
  Crt;
const
  n=8;
type
  TTablica = array [1..n] of Integer;

procedure sort_szybki(var t : TTablica; indPocz ,IndKon : Integer);
var
  i,j   : Integer;
  pivot,              { element dzielcy }
  pom   : Integer;
begin
  i:=indPocz;
  j:=indKon;
  pivot:=t[(indPocz+indKon) div 2]; { wyznaczamy pivota }
  repeat
    while t[i]<pivot do Inc(i); { szukamy elementu wikszego od pivota  }
    While pivot<t[j] do Dec(j); { szukamy elementu mniejszego od pivota }
    if i<=j then
      begin
        pom:=t[i];  { jeli znalelimy takie elementy  }
        t[i]:=t[j]; { to zamieniamy je miejscami        }
        t[j]:=pom;
        i:=i+1;
        j:=j-1;
     end;
  until i>j;
  if indPocz<j Then sort_szybki(t,IndPocz,j); { sortujemy lewa cz  }
  if i<IndKon Then sort_szybki(t,i,IndKon); { sortujemy prawa cz }
end;

const

  tab : tTablica=(29,14,9,5,3,2,37,15);
var
  i : Integer;
begin
  clrscr;
  writeln('Sortowanie szybkie');
  writeln('Tablica przed sortowaniem');
  for i:=1 to n do write(tab[i],' ');
  writeln;
  sort_szybki(tab,1,n);

  writeln('Tablica po sortowaniu');
  for i:=1 to n do write(tab[i],' ');
  writeln;

  repeat until keypressed;
end.
