{ Program oblicza pole metod trapezw }
program metoda_trapezow;
uses
  Crt;

{ Funkcja, pod wykresem ktrej liczymy pole }
function f(x : Real) : Real;
begin
  f:=x*x-1
end;

{ Funkcja oblicza pole metod trapezw }
{ parametry: }
{ a, b - koce przedziaw }
{ n - liczba podziaw }
function wzor_trapezow(a,b : Real; n : Integer) : Real;
var
  i : Integer;
  h,
  suma : Real;
begin
  h:=(b-a)/n; { wyznaczamy wysoko trapezu }
  suma :=0;
  { wyliczamy wartoci funkcji w punktach podziau: }
  { x1=a+h, x2=a+2*h, x3=a+3*h, ..., xn-1=a+(n-1)*h, }
  { i wartoci funkcji w tych punktach sumujemy }
  for i:=1 TO n-1 do
    suma:=suma+f(a+i*h);
  wzor_trapezow:=(f(a)+f(b)+2*suma)*h/2
end;

var
  a,b,         { koce przedziau <a,b> }
  roznica, e,
  pole1, pole2 : Real;
  n : Integer; { liczba podziaw }
begin
  clrscr;
  writeln('Podaj koce przedziaw <a,b>:');

  write('a= ');
  readln(a);

  write('b= ');
  readln(b);

  writeln('oraz dokadno z jak obliczymy pole:');
  write('E= ');
  readln(e);

  writeln;
  writeln('Wartoci naszego pola w zalenoci od podziau:');
  writeln;
  n:=2;

  { obliczamy pole dla podziau n=2 }
  pole1:=wzor_trapezow(a,b,n);
  repeat
    { zwikszamy podzia dwukrotnie }
    n:=2*n;

    { obliczamy pole dla nowego podziau }
    pole2:=wzor_trapezow(a,b,n);

    { obliczamy rnice pomidzy polem z poprzednim }
    { podziaem a polem z obecnym podziaem }
    roznica:=abs(pole2-pole1);
    writeln('Dla podziau n= ',n:5,' pole wynosi: ',pole2:12:9);
    pole1:=pole2;

    { tak dugo krcimy si w ptli dopki rnica }
    { bdzie mniejsza od podanej dokadnoci }
  until roznica<e;

  repeat until keypressed;
end.
