{ Program na podstawie trzech dugoci bokw bada czy mona }
{ zbudowa trjkt. A jeli mona to okrela jakiego rodzaju. }
program trojkat;
uses
  Crt;

{ Funkcja sprawdza czy dugoci bokw a, b, c tworz }
{ jakikolwiek trjkt }
function warunek_trojkata (a,b,c : real) : Boolean;
begin
  warunek_trojkata:=((a+b)>c)
                    and
                    ((a+c)>b)
                    and
                    ((b+c)>a);
end;

{ Funkcja sprawdza czy dugoci bokw a, b, c tworz }
{ trjkt prostoktny }
function prostokatny (a,b,c : real) : Boolean;
begin
  prostokatny:=(sqr(a)=(sqr(b)+sqr(c)))
               or
               (sqr(b)=(sqr(a)+sqr(c)))
               or
               (sqr(c)=(sqr(a)+sqr(b)));
end;

{ Funkcja sprawdza czy dugoci bokw a, b, c tworz }
{ trjkt ostroktny }
function ostrokatny (a,b,c : real) : Boolean;

begin
  ostrokatny:=(sqr(a)<(sqr(b) +sqr(c)))
              and
              (sqr(b)<(sqr(a) +sqr(c)))
              and
              (sqr(c)<(sqr(a) +sqr(b)));

end;

{ Funkcja sprawdza czy dugoci bokow a, b, c tworz }
{ trjkt rozwartoktny }
function rozwartokatny (a,b,c : real) : Boolean;
begin
  rozwartokatny:=(sqr(a)>(sqr(b)+sqr(c)))
                 or
                 (sqr(b)>(sqr(a)+sqr(c)))
                 or
                 (sqr(c)>(sqr(a)+sqr(b)));

end;

{ Procedura sprawdza czy na podstawie bokw a, b i c mona zbudowa trjkt }
{ W pierwszym kroku wykluczamy dugoci bokw ujemne i rwne 0 }
procedure sprawdzTrojkat (a,b,c : real);
var
  wynik : Byte;
begin
  wynik:=0;
  if (a=0) or (b=0) or (c=0) or
     (a<0) or (b<0) or (c<0) then wynik:=1
  else
    if warunek_trojkata(a,b,c) then
    begin
      write('Moemy zbudowa trjkt ');
      if prostokatny(a,b,c) then wynik:=2
      else
        if ostrokatny(a,b,c) then wynik:=3
        else
          if rozwartokatny(a,b,c) then wynik:=4;
    end;
  case wynik of
  0 : writeln('Nie mona zbudowa trjkta');
  1 : writeln('Dugoci nie mog by liczbami ujemnymi lub rwnymi zero');
  2 : writeln('prostoktny');
  3 : writeln('ostroktny');
  4 : writeln('rozwartoktny');
  end;
end;

var
  a,b,c : Real;
begin
  clrscr;

  writeln('Wprowad dugoci bokw trjkta');
  write('a = ');
  readln(a);

  write('b = ');
  readln(b);

  write('c = ');
  readln(c);

  sprawdzTrojkat (a,b,c);

  repeat until keypressed;
end.
