{ Program bada pooenie punktw wzgldem prostej }
program prosta_p;
uses
  Crt;

type
  TPunkt=Record { Rekord przechowujcy dane o punkcie }
    x : Real;
    y : Real;
  end;

{ Procedura pomocnicza, ktra zbiera info o punkcie w jednym rekordzie }
procedure punkt(x, y : Real; var punkt : TPunkt);
begin
  punkt.x:= x;
  punkt.y:= y;
end;

{ Funkcja sprawdza czy dwa punkty s sobie rwne, czyli czy odpowiednie  }
{ wsprzdne s sobie rwne }
function czy_pkt_rowne(p1,p2 : TPunkt) : Boolean;
begin
  czy_pkt_rowne:=(p1.x=p2.x)and(p1.y=p2.y);
end;

{ Funkcja sprawdza czy punkt naley do prostej }
{ Parametry wejciowe: m - wspczynnik kierunkowy, b - wyraz wolny prostej }
{ p - punkt }
function czy_do_prostej(m,b : Real; p : TPunkt) : Boolean;
var
  wynik : Boolean;
  y : Real;
begin
  wynik:=false;
  { 1. podstawiam wsprzdna x punktu p do rwnania prostej i otrzymuje y }
  { 2. porwnuje y z prostej ze wsprzdn y punktu p }
  y:=m*p.x + b;

  if y=p.y then wynik:=true;
  czy_do_prostej:=wynik;
end;

var
  m,   b : Real;
  p1, p2 : TPunkt;
begin
  clrscr;
  writeln('Program bada pooenie dwch punktw wzgldem prostej w postaci y = mx + b');

   { sekwencja zabezpieczajca przed wprowadzeniem nieprawidowych danych }
   { obecnie nie ma znaczenia, ale przyda Ci si jeli dane dotyczce prostej }
   { bdziesz wprowadza z klawiatury }
  {$I-}
    m:=2;
    b:=1;
  {$I+}

  if IoResult = 0 then
    begin
      writeln('Prosta ma posta: y =',m:6:2,'*x +',b:6:2);
      writeln;
      punkt(0,1,p1);
      punkt(0,0,p2);

      writeln('Punkty s o nastpujcych wsprzdnych:');
      writeln('p1 = (',p1.x:6:2,',',p1.y:6:2,')');
      writeln('p2 = (',p2.x:6:2,',',p2.y:6:2,')');

      writeln;
      { sprawdzamy czy przypadkiem dwa punkty nie s tym samym punktem }
      { wtedy sprawdzamy tylko raz }

      if czy_pkt_rowne (p1,p2) then
        begin
          write('Punkty p1 i p2 pokrywaj si');
          if czy_do_prostej(m,b,p1) then writeln(' i nale do prostej')
          else
            writeln('i znajduj si poza prosta');
        end
      else
        begin
          if czy_do_prostej(m,b,p1) then writeln('Punkt p1 naley do prostej')
          else
            writeln('Punkt p1 znajduje si poza prost');

          if czy_do_prostej(m,b,p2) then writeln('Punkt p2 naley do prostej')
            else writeln('Punkt p2 znajduje si poza prost');
        end;
    end
  else
    writeln('Wprowadzone dane s nieprawidowe');

  repeat until keypressed;
end.
