{ Program sprawdza czy dwa cigi znakw tworz anagramy }
{ Jeli tak, to przydziela je do jednej grupy }
program angram;
uses
  Crt;

const
  ileSlow = 4;
type
  { tablica przechowujca due litery }
  TIleLiter = array['A'..'Z'] of Byte;
  { tablica slow }
  TSlowa = array [1..ileSlow] of TIleLiter;

var
  GrupaSlow : TSlowa;
  NrGrupy : Byte;

{ Procedura zlicza w sowie ilo wystpie poszczeglnych liter }
{ W parametrze przekazywanym przez zmienn zwracana jest tablica }
{ poszczeglnych wystpie liter }
procedure zlicz_litery( slowo : String; var ileLiter : TIleLiter);
var
  i : Byte;
begin
  fillchar(ileLiter,sizeof(ileLiter),0);
  for i:=1 to length(slowo) do
    { kolejne znaki w sowie zamieniam na due litery i zwikszam }
    { licznik na odpowiednim miejscu w tabeli ileLiter }
    inc(ileLiter[upcase(slowo[i])]);
end;

{ Funkcja sprawdza czy slowo1 jest anagramem slowa2, czyli }
{ czy jedno i drugie sowo ma tak sam ilo poszczeglnych liter }
function sprawdz_slowo (var slowo1,slowo2 : TIleLiter) : Boolean;
var
  i : Char;
  wynik : Boolean;
begin
  wynik:=true;
  i:='A';
  while (i in ['A'..'Z']) and wynik  do
    { wystarczy, e sowa rni si iloci jednej z liter, }
    { to koczymy przeszukiwanie: wynik:=false }
    begin
      if slowo1[i]<>slowo2[i] then wynik:=false;
      inc(i);
    end;
   sprawdz_slowo:=wynik;
end;

{ Funkcja szuka grupy, do ktrej naley sowo lub tworzy nowa grup }
{ jeli takiej nie ma }
function szukaj_grupy (ileLiterWSlowie : TIleLiter) : Byte;

var
  dalej : Boolean;
  i : Byte;
begin
  dalej:=true;
  i:=1;
  while (i<=NrGrupy) and dalej do
    begin
      if sprawdz_slowo(ileLiterWSlowie,GrupaSlow[i]) then
        begin
         szukaj_grupy:=i;
         dalej:=false;
        end;
      inc(i);
    end;

  if dalej then
    begin
      inc(NrGrupy);
      GrupaSlow[NrGrupy]:=ileLiterWSlowie;
      szukaj_grupy:=NrGrupy;
    end;
end;

{ Funkcja na podstawie sowa zlicza ilo wystpowania danych liter }
{ i okrela dla niego numer grupy }
function nr_grupy (slowo : String):Byte;
var
  ileLiterWSlowie : TIleLiter;
begin
  zlicz_litery(slowo,ileLiterWSlowie);
  nr_grupy:=szukaj_grupy(ileLiterWSlowie);
end;

{ Funkcja pobiera znaki z klawiatury i czy je w sowo }
{ Klawisz Enter koczy pobieranie znakw dla jednego sowa }
{ W czasie wprowadzania moemy uy BackSpace, jeli pomylimy }
{ si podczas wprowadzania tekstu }
function pobierz_slowo : String;
var
  znak : Char;
  slowo : String;
begin
  slowo:='';
  write('Podaj sowo: ');
  repeat
    znak:=upcase(readkey);
    case znak of
      'A'..'Z' : if length(slowo)<250 then
                   begin
                     slowo:=slowo + znak;
                     write(znak);
                   end;

            #8 : if length(slowo)>0 then
                   begin
                     slowo[0]:=char(Byte(slowo[0])-1);
                     gotoxy(wherex-1,wherey);
                     write(' ');
                     gotoxy(wherex-1,wherey);
                 end;
    end;
  until ((znak = #13) and (slowo<>''));
  pobierz_slowo:=slowo;
  write(' ' );
end;
var
  ile   : Byte;
  Slowo : String;
begin
  Clrscr;
  ile:=0;
  NrGrupy:=0;
  writeln('Program sprawdzi, ktre z podanych sw s anagramami.');
  writeln('Podaj 4 sowa. Klawisz Enter koczy pobieranie znakw dla jednego sowa.');
  writeln('Podczas wprowadzania w razie pomyki moemy uy klawisza BackSpace.');
  { W trakcie dziaania programu poszczeglne sowa s przydzielane }
  { do odpowiednich grup na podstawie iloci wystpowania danych liter. }
  { Nie zwracamy uwag na wielko wpisywanych liter poniewa wszystkie }
  { zamieniamy na due w funkcji pobierz sowo }
  repeat
    slowo:=pobierz_slowo;
    writeln(nr_grupy(Slowo),' Grupa');
    inc(ile);
  until (ile = ileSlow);
  writeln('Sowa nalece do tych samych grup s anagramami');
  repeat until keypressed;
end.
