program szukanie_min_max_rek;
uses
  Crt;
const
  n=7;
type
  { n jest nieparzyste, wiec dodajemy jeden element na kocu }
  TTablica = array [1..n+1] of Integer;


{ procedura wyszukujca w tablicy t min i max pomidzy elementami }
{ wyznaczonymi przez indeksy lewy i prawy }
procedure szuk_min_max_rek(t : TTablica; lewy, prawy : Integer; var min, max : Integer );
var
  min1, max1,
  min2, max2,
  srodek : Integer;
begin
  if lewy=prawy then  { jeli indeksy wskazuj na ten sam element }
     begin            { to zarwno min=max }
       min:=t[lewy];
       max:=t[prawy];
     end
   else
     if lewy=(prawy-1)then  { jeli indeksy wskazuj na ssiednie elementy}
       begin                { czyli porwnujemy ssiedni par }
         if t[lewy]<t[prawy] then
           begin
             min:=t[lewy];
             max:=t[prawy];
           end
         else
           begin
             min:=t[prawy];
             max:=t[lewy];
           end
       end
     else
       begin

        { Rozdzielamy zbir na dwa podzbiory }
        { i w kadym wyszukujemy minimum i maksimum }

         srodek:=(lewy+prawy) div 2; { dzielimy tablice na p }
         szuk_min_max_rek(t, lewy, srodek, min1, max1);
         szuk_min_max_rek(t, srodek+1, prawy, min2, max2);

         if (min1<min2) then min:=min1
         else min:=min2;

         if (max1>max2) then max:=max1
         else max:=max2;
       end;
end;

const
  tab : TTablica=(29,14,9,5,3,37,15,15);
var
  i,
  min,
  max : Integer;
begin
  clrscr;
  writeln('Jednoczesne wyszukiwanie elementu minimalnego i maksymalnego');
  writeln('------------------------------------------------------------');
  write('Tablica skada si z elementw: ');
  for i:=1 to n do write (tab[i],' ');
  writeln;
  writeln('------------------------------------------------------------');
  szuk_min_max_rek(tab,1,n+1,min,max);
  writeln('Metoda optymalna (rekurencyjna) Min ',min,' Max ',max);

  repeat until keypressed;
end.
