program szukanie_min_max;
uses
  Crt;
const
  n=7;
type
  { n jest nieparzyste, wic dodajemy jeden element na kocu }
  TTablica = array [1..n+1] of Integer;

{ procedura wyszukujca jednoczesne min i max metod naiwn }
procedure szuk_min_max_1(t : TTablica; n : Integer; var min, max : Integer );
var i: integer;
begin
  min:=t[1];
  max:=t[1];
  for i:=2 to n do { sprawdzamy kady element czy jest minimalny czy maksymalny }
    begin
      if t[i] < min then min:=t[i]
      else
        if t[i] > max then max:=t[i];
    end;
end;

{ procedura wyszukujca jednoczesne min i max metod optymaln }
procedure szuk_min_max_2(t : TTablica; n : Integer; var min, max : Integer );
var
  i,
  indMin,
  indMax : Integer;
begin
  min := t[1];
  max := t[1];
  indMin := 1;
  indMax := 1;

  i := 1;
  while i <= n do
    begin
      if t[i] < t[i+1] then { badamy dwa kolejne elementy }
        begin
          if t[i] < min then
            begin
               min := t[i];
              indMin := i;
            end;
          if t[i+1] > max then
            begin
              max := t[i+1];
              indmax := i+1;
            end;
        end
      else
        begin
          if t[i+1] < min then
            begin
               min := t[i+1];
               indMin := i+1;
            end;
          if t[i] > max then
            begin
              max := t[i];
              indMax := i;
            end;
    end;
    inc(i,2); { przesuwamy si do dwch nastpnych }
  end;

  if indMin = n + 1 then dec(indMin);
  if indMax = n + 1 then dec(indMax);
end;

const
  { dodajemy element na kocu (powtarzamy ostatni) aby bya parzysta }
  { ilo w tablicy - nie ma to znaczenia dla wyszukiwania }
  tab : TTablica=(29,14,9,5,3,37,15,15);
var
  i,
  min,
  max : Integer;
begin
  clrscr;
  writeln('Jednoczesne wyszukiwanie elementu minimalnego i maksymalnego');
  writeln('------------------------------------------------------------');
  write('Tablica skada si z elementw:');
  for i:=1 to n+1 do write (tab[i],' ');
  writeln;
  writeln('------------------------------------------------------------');
  szuk_min_max_1(tab,n+1,min,max);
  writeln('Metoda naiwna    Min ',min,' Max ',max);
  if odd(n) then begin
    szuk_min_max_2(tab,n+1,min,max);
    writeln('Metoda optymalna Min ',min,' Max ',max);
  end else begin
    writeln;
    writeln('Obecnie tablica ma nieparzyst ilo elementw. Procedura wyszukujca');
    writeln('metod optymaln bazuje na tablicy o parzystej iloci elementw.');
  end;
  repeat until keypressed;
end.
