program sortowanie_przez_scalanie;
uses
  Crt;
const
  n=7;
type
  TTablica  = array [1..n] of Integer;

procedure WypelnijTablice(var tab : TTablica; n : Integer );
var
  i : Integer;
begin
  writeln('Podaj ',n,' liczb');
  for i:=1 to n do readln(tab[i]);
end;

{ Procedura scalajca dwa posortowane cigi t[indPocz..indSrodek] z }
{ t[indSrodek+1..indKon] przy wykorzystaniu tablicy pomocniczej temp }
procedure scalaj(var t : TTablica; indPocz, indSrodek, indKon : LongInt);
var
  i, j,
  k    : Integer;
  temp : TTablica;
begin
  i := indPocz;
  j := indSrodek + 1;
  k := indPocz;
  while (i <= indSrodek) and (j <= indKon) do
    begin
      if t[i] < t[j] then  { sprawdzamy, ktry element jest mniejszy }
        begin
          temp[k] := t[i]; { mniejszy zapisujemy do temp }
          Inc(i);
        end
      else
        begin
          temp[k] := t[j]; { mniejszy zapisujemy do temp }
          Inc(j);
        end;
      Inc(k);
    end;

  while i <= indSrodek do { jeli w t[1..indSrodek] pozostay elementy }
    begin
      temp[k] := t[i];    { przepisujemy do temp }
      Inc(i);
      Inc(k);
    end;

  while j <= indKon do    { jeli w t[indSrodek+1..indKon] pozostay elementy }
    begin
      temp[k] := t[j];    { przepisujemy do temp }
      Inc(j);
      Inc(k);
    end;

  { Przepisujemy zawarto tablicy temp do tablicy t }
  for i := indPocz to indKon do t[i] := temp[i];
end;

procedure sort_scal(var t : TTablica; indPocz, indKon : LongInt);
var
  indSrodek : LongInt;
begin
  if indPocz < indKon then
  begin
    indSrodek := (indPocz + indKon) div 2;
    sort_scal(t,indPocz,indSrodek);
    sort_scal(t,indSrodek + 1,indKon);
    scalaj(t,indPocz, indSrodek, indKon);
  end;
end;


const
  tab  : TTablica=(9,5,14,19,2,3,15);
var
  i : Integer;
begin
  clrscr;
  writeln('Sortowanie przez scalanie');
  writeln('Tablica przed sortowaniem');
  for i:=1 to n do write(tab[i],' ');
  writeln;

  sort_scal(tab,1,n);
  writeln('Tablica po sortowaniu');
  for i:=1 to n do write(tab[i],' ');
  writeln;

  repeat until keypressed;
end.
