program metoda_Newtona_Raphsona ;
uses
  crt;

{ Funkcja liczca pierwiastek z liczby rzeczywistej a. }
{ W wyniku zwracamy przyblion warto pierwiastka }
function sqrt_N_R(a : Real) : Real;
const
  Epsilion = 0.000001; { dokadno z jak obliczamy pierwiastek }
var
  x : Real;
begin
  x:=a/2;
  while abs(x-a/x) > Epsilion do
    x:=0.5 * (x + a/x);

  sqrt_N_R:=x;
end;

var
  a : Real;
begin
  clrscr;
  writeln('Obliczanie pierwiastka kwadratowego - metoda Newtona-Raphsona');
  write('Podaj liczb: ');
  readln(a);
  { zabezpieczamy si przed prba obliczania pierwiastka z liczby ujemnej }
  if a >= 0.0 then
    begin
      writeln('Pierwiastek kwadratowy z liczby wynosi: ');
      writeln('  nasza funkcja: ', sqrt_N_R(a):8:4);
      writeln('  funkcja sqrt: ', sqrt(a):8:4);
    end
  else
    writeln('Nie obliczamy pierwiastka z liczby ujemnej');

  repeat until keypressed;
end.
