program szybkie_potegowanie;
uses
  Crt;

{ Zamiana dowolnej liczby w systemie dziesitnym na jej reprezentacje }
{ w dowolnym systemie pozycyjnym o podstawie od 2 do 10 }
{ Wykorzystujemy do zamiany na posta binarn }
procedure dzies_na_p(l10 : Longint; p : Byte;
                     var lx : String);
begin
  lx:='';
  repeat
    lx:=chr( (l10 mod p) + ord('0') ) + lx;
    l10:=l10 div p;
  until l10 = 0;
end;

function potega_iter(x : Longint; n : Word) : Longint;
var
  y    : Longint;
  nBin : string;
  i,c  : Byte;
begin
  y:=x;                 { pierwszy bit jest zawsze 1, wic przyjmujemy, e y:=x }
  dzies_na_p(n,2,nBin); { zamieniamy wykadnik na posta binarn }
  for i := 2 to length(nBin) do     { zaczynamy bada od 2-giego bitu od lewej }
    begin
      c := ord(nBin[i]) - ord('0'); { odczytujemy poszczeglne cyfry }
      if c=0 then
        y:=y*y
      else
        y:=y*y*x
    end;

  potega_iter:=y
end;

function potega_rek(x : Longint; n : Word) : Longint;
begin
  if n=1 then potega_rek:=x
  else
    { funkcja odd bada czy argument (u nas n) jest liczb nieparzyst }
    if odd(n) then
      potega_rek:=potega_rek(x,n div 2)*potega_rek(x,n div 2)*x
    else
      potega_rek:=potega_rek(x,n div 2)*potega_rek(x,n div 2)
end;

var
  liczba    : Longint;
  wykladnik : Word;
begin
  clrscr;
  writeln('Szybkie potgowanie - wykorzystanie schematu Hornera');
  writeln('----------------------------------------------------');
  write('Podaj liczb: ');
  readln(liczba);
  write('Podaj wykadnik: ');
  readln(wykladnik);
  { dodaj zabezpieczenia przed wprowadzeniem nieprawidowych danych }
  writeln('Metoda iteracyjna');
  writeln('Potga wynosi ', potega_iter(liczba,wykladnik));
  writeln('Metoda rekurencyjna');
  writeln('Potga wynosi ', potega_rek(liczba,wykladnik));

  repeat until keypressed;
end.
W przykadzie znajdziesz zarwno wersj iteracyjn jak i rekurencyjn szybkiego podnoszenia do potgi. W programie wykorzystalimy funkcj z poprzedniego rozdziau, ktra zamienia liczb dziesitn na
 posta binarn.
